<% option explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="navigation.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/helperFunctions.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/difficultyLevels.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/categories.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/maturityLevels.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/fckeditor.vbs"></script><%
CheckHeader "Properties.aspx"

Dim Action : Action = LCase(Request.Form("pbAction"))
Dim Value : Value = Request.Form("pbValue")
Dim IsPostBack : IsPostBack = Not IsEmpty(Request.Form("IsPostBack"))
Dim IsDuplicate : IsDuplicate = False
Dim GameID : If Len(Request.Form("GameID")) _
	Then GameID = CLng(Request.Form("GameID")) _
	Else GameID = CLng(Request.QueryString())
Dim Conn
	Set Conn = Server.CreateObject("ADODB.Connection")
	Conn.Open Application("ConnectionString")

	
ValidateGameWithConn GameID, Conn

If IsPostBack Then Save

Select Case Action
	Case "nav" : Navigate Value,GameID
	Case "coauthors" : Response.Redirect "coauthors.asp?" & GameId
End Select		

Sub Save()
	Dim catID, matID, difID
	If Request.Form("Category ID")="" Then catID=Null Else catID=CLng(Request.Form("Category ID"))
	If Request.Form("Maturity Level Id")="" Then matID=Null Else matID=CLng(Request.Form("Maturity Level Id"))
	If Request.Form("Difficulty Level Id")="" Then difID=Null Else difID=CLng(Request.Form("Difficulty Level Id"))
	
	Dim OriginalTitle
	With Conn.Execute("SELECT [Title] FROM [Games] WHERE [Game ID]=" & GameID)
		OriginalTitle = .Fields(0).Value
	End With
	
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = "SELECT 1 FROM [Games] WHERE [Title]=? AND [Game ID]<>?"
		.Parameters.Append .CreateParameter("Title",200,1,250,Request.Form("Title"))
		.Parameters.Append .CreateParameter("GameID",3,1,8,GameID)
		IsDuplicate = Not .Execute.EOF
	End With
			
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"UPDATE [Games] SET [Title]=?,[Description]=?,[Category ID]=?," & _
			"       [Maturity Level Id]=?,[Difficulty Level Id]=?,[Allow Saves Indicator]=?, " & _
			"       [AllowPreview_Indicator] = ? " & _
			" WHERE [Game ID]=?"
		If IsDuplicate Then
		  .Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,250,OriginalTitle)
		Else
		  .Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,250,Request.Form("Title"))
		End If
		.Parameters.Append .CreateParameter("Description",adLongVarChar,adParamInput,2147483647,Request.Form("Description"))
		
		.Parameters.Append .CreateParameter("Category ID",adInteger,adParamInput,8,catID)
		.Parameters.Append .CreateParameter("Maturity Level Id",adInteger,adParamInput,8,matID)
		.Parameters.Append .CreateParameter("Difficulty Level Id",adInteger,adParamInput,8,difID)
		
		.Parameters.Append .CreateParameter("Allow Saves Indicator",adChar,adParamInput,1,"N")
		If Request.Form("Allow Saves Indicator") = "Y" Then .Parameters("Allow Saves Indicator").Value = "Y"
		
		.Parameters.Append .CreateParameter("AllowPreview_Indicator",adChar,adParamInput,1,"N")
		If Request.Form("AllowPreview_Indicator") = "Y" Then .Parameters("AllowPreview_Indicator").Value = "Y"
		

		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,8,GameID)		
		.Execute
	End With
	
	If IsDuplicate Then Action=""
End Sub

Dim Coauthors
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Conn
	.CommandText = "SELECT [Username] FROM [Game Coauthors] WHERE [Game Id] = ? AND [Active Indicator] = 'Y'"
	.Parameters.Append .CreateParameter("GameID", adInteger, adParamInput, 8, GameID)
	With .Execute
		Do While Not .EOF
			If Not IsEmpty(Coauthors) Then Coauthors = Coauthors & ", "
			Coauthors = Coauthors & .Fields("Username").Value
			.MoveNext
		Loop
	End With
End With

%>

<% If IsDuplicate Then %>
<script defer>
	alert("The Title could not be changed because it is in use by another game. The other fields have been saved.");
</script>
<% End If %>


		<div id="maincontent">

<h1>Advanced Editor &raquo; Properties</h1>		
	
<% WriteSecondaryNavigation %>		
		<div>
		&nbsp;&nbsp;<span class="smallerText">Overwhelmed? Make sure to read <a href="/help/articles/article.aspx?ArticleId=3">Chapters, Pages, and Links</a>.</span>
		</div>		
		
		<form name="mainForm" method="post" style="padding-left:15px;">

<%
 With Server.CreateObject("ADODB.Command")
 	.ActiveConnection = Conn
	.CommandText = _
		"SELECT ISNULL([Title],'') [Title], [Username], [Allow Saves Indicator], " & _
		"       [Category ID], [Maturity Level Id], [Difficulty Level Id], " & _
		"       ISNULL([Description],'') [Description], AllowPreview_Indicator " & _
		"  FROM [Games] " & _
		" WHERE [Game ID] = ?"
	.Parameters.Append .CreateParameter("GameID", adInteger, adParamInput, 8, GameID)
	With .Execute
%>
		  <input type="hidden" name="pbAction" value="">
		  <input type="hidden" name="pbValue" value="">
		  <input type="hidden" name="GameID" value="<%=GameID%>">
		  <input type="hidden" name="IsPostBack" value="true">
		<label>Title</label><br/>
		<input onChange="dataChanged=true;" type="text" name="Title" maxlength="100" size="75" value="<%=Server.HTMLEncode(.Fields("Title"))%>"><br/>
		<br/>
		<label>Description</label><br/>
		<%  Dim Description : Description = .Fields("Description")
			With (New FCKeditor)
				.Width = "85%"
				.Value = Description
				.Create "Content"
			End With
		%>
		<br/>
		<label>Category</label><br/>
		<select name="Category ID" onChange="dataChanged=true;">
		  <option value=""></option>
 		  <%WriteCategoryOptions(.Fields("Category ID"))%>
		</select><br/>
		<br/>
		<label>Maturity Level</label><br/>
		<select name="Maturity Level Id" onChange="dataChanged=true;">
		  <option value=""></option>
 		  <%WriteMaturityLevelOptions(.Fields("Maturity Level Id"))%>
		</select><br/>
		<br/>
		<label>Difficulty Level</label><br/>
		<select name="Difficulty Level Id" onChange="dataChanged=true;">
		  <option value=""></option>
 		  <%WriteDifficultiesOptions(.Fields("Difficulty Level Id"))%>
		</select><br/>
		<br/>
		<label>Coauthors</label><br/>
		<% If IsEmpty(Coauthors) Then %>
		You have not selected any coauthors for your game. <br/>
		<% Else %>
		<%=Coauthors%><br/>
		<% End If %>
		<% If .Fields("Username").Value = Session("Username") Then %>
		<a href="coauthors.asp?<%=GameId%>" onclick="PostBack('coauthors');">[edit co-authors]</a><br/>
		<% End If %>
	
		<% If .Fields("Username").Value = Session("Username") Then %>
		<br/>
		<input type="checkbox" name="AllowPreview_Indicator" value="Y" id="allowPreview"
			<%If .Fields("AllowPreview_Indicator").Value="Y" Then Response.Write " checked"%>/>
		<label for="allowPreview">Allow Sneak Preview</label><br/>
		<div class="smallerText">
		When this box is checked, this storygame will be visible (but not clickable) on
		your profile page. If unchecked, only the author(s) may view it and it will not be
		shown in your profile.		</div>	
		<% End If %>
		<br/>
		<input type="button" value="Save Changes" onClick="PostBack('save');">
<%
	End With
  End With
%>		
		</form>
		</div>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
<% Conn.Close %>