<!-- #include file ="constants.inc" -->
<!-- #include file="Includes/Request_Start.inc.asp" -->

<script runat="server" language="vbscript" src="Includes/logger.vbs"></script>
<script runat="server" language="vbscript" src="Includes/CheckHeader.vbs"></script>
<%CheckHeader "NewGame.aspx"
  const THIS_FILE = "newgame.asp"
If Not Session("LoggedOn") Then Response.Redirect("logon.aspx")
     dim strUserName, intUserID
     strUserName = Session("Username")

    'GET VARIABLES
    dim strGameTitle,strGameDescription,intGamePreferences,pageno
    strGameTitle = Trim(Replace((request("strGameTitle")),"""","&#34;"))
    strGameDescription = Trim(Replace((request("strGameDescription")),"""","&#34;"))
    intGamePreferences = int(request("intGamePreferences"))
    pageno = int(request("pageno"))

    'CHANGE PAGENO
    if left(request("A"),4) = "Next" then pageno=pageno+1
    if right(request("A"),8) = "Previous" then pageno=pageno-1
    if request("A") = "Cancel" then
      response.redirect("my/games.aspx")
    end if
    if request("a") = "Finish" then
      Dim ggid : ggid = NewGame()
	  response.redirect("my/adveditor/?" & ggid)
    end if

	'check for duplicate title
	If pageno = 1 and left(request("A"),4) = "Next" Then
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Application("ConnectionString")
			.CommandText = "SELECT 1 FROM [Games] WHERE [Title] LIKE ?"
			.Parameters.Append .CreateParameter("@Title",adVarChar,adParamInput,255,strGameTitle)
			If Not .Execute.EOF Then
				pageno = 0
				Response.Write "<script>alert('Whoops! A game with that title already exists. Please choose a different title');</script>"
			End If
		End With
	End If

%>
<form method="post" style="margin-top: 0px;">
    <h1 style="margin-bottom: 0px;"><a href="./my/">My Stuff</a> &raquo; <a href="./my/games.aspx"><%=Session("StoryProperPlural") %></a> &raquo; New <%=Session("StoryProper") %></h1>
    <table width="100%" border="0" cellpadding="0" cellspacing="0">
        <%select case pageno:case 0%>
        <tr>
            <td width="10" valign="top" rowspan="2">&nbsp;</td>
            <td width="600" valign="middle" class="maintext">
                <p>
                    This wizard will help you in creating a new <%=Session("StoryProper") %>.
              Before you begin, make sure you've read
              <a href="/help/articles/article.aspx?ArticleId=4284" target="_blank">Storygame Creating 101.</a>
                </p>

                <p>Additionally, please be aware that your storygame must meet the <a href="/help/articles/article.aspx?ArticleId=38" target="_blank">minimum site standards</a> before you publish it.</p>

                <p>
                    <b>Step One: Choose A Title</b><br>
                    Think carefully when creating a title. A title should be only
                a few words and should attract players to your game. Type your
                title in the box below. You can always change this title later.
                Once you've typed in a name, click the Next button to continue!
                </p>
                <p>
                    <input type="hidden" name="pageno" value="<%=pageno%>">
                    <input type="text" name="strGameTitle" value="<%=strGameTitle%>" autofocus="true">
                    <input type="hidden" name="strGameDescription" value="<%=strGameDescription%>">
                    <input type="hidden" name="intGamePreferences" value="<%=intGamePreferences%>">
                </p>
            </td>
            <td width="10" rowspan="2" valign="top">&nbsp;</td>
        </tr>
        <tr>
            <td valign="middle" height="33">
                <input type="submit" name="A" value="Cancel">
                <input type="submit" name="A" value="Next &raquo;">
            </td>
        </tr>
        <%case 1%>
        <tr>
            <td valign="top" rowspan="2">&nbsp;</td>
            <td valign="middle" class="maintext" height="240">
                <p>
                    <b>Step Two: Describe Your Game</b><br>
                    You should be sure to give players a fair idea of what type of
                game they will be playing. If your game is serious or funny, make
                sure to note that. Type your description in the box below. This
                can also be changed later.
                </p>
                <p>
                    <input type="hidden" name="pageno" value="<%=pageno%>">
                    <input type="hidden" name="strGameTitle" value="<%=strGameTitle%>">
                    <input type="hidden" name="intGamePreferences" value="<%=intGamePreferences%>">
                    <textarea rows="8" cols="55" name="strGameDescription" autofocus="true"><%=strGameDescription%></textarea>
                </p>
            </td>
            <td rowspan="2" valign="top">&nbsp;</td>
        </tr>
        <tr>
            <td valign="middle" height="33">
                <input type="submit" name="A" value="Cancel">
                <input type="submit" name="A" value="&laquo; Previous">
                <input type="submit" name="A" value="Next &raquo;">
            </td>
        </tr>
        <%case 2%>
        <tr>
            <td valign="top" rowspan="2">&nbsp;</td>
            <td valign="middle" class="maintext" height="117">
                <p>
                    <b>Finished!<br>
                    </b>You are now ready to start creating your game!
                </p>
            </td>
            <td rowspan="2" valign="top">&nbsp;</td>
        </tr>
        <tr>
            <td valign="middle" height="33">
                <input type="hidden" name="pageno" value="<%=pageno%>">
                <input type="hidden" name="strGameTitle" value="<%=strGameTitle%>">
                <input type="hidden" name="strGameDescription" value="<%=strGameDescription%>">
                <input type="hidden" name="intGamePreferences" value="<%=intGamePreferences%>">
                <input type="submit" name="A" value="Cancel">
                <input type="submit" name="A" value="&laquo; Previous">
                <input type="submit" name="A" value="Finish">
            </td>
        </tr>
        <%end select%>
    </table>

    <% function NewGame()
       dim rst, intGameID

	   If Session("Rich Text Editor Indicator") = "Y" Then
		   strGameDescription = "<p>" & Replace(strGameDescription,vbCrLf & vbCrLf,"</p><p>") & "</p>"
		   strGameDescription = Replace(strGameDescription,vbCrLf,"<BR>")
		  End If

	With Server.CreateObject("ADODB.Command")
		.ACtiveConnection = Application("ConnectionString")
		.CommandType = adCmdStoredProc
		.CommandText = "[Create New Game]"
		.Parameters.Append .CreateParameter("@GameType",adVarChar,adParamInput,8)
		If (intGamePreferences AND IS_CLASSIC) Then .Parameters("@GameType").Value = "Classic" Else .Parameters("@GameType").Value = "Advanced"
		.Parameters.Append .CreateParameter("@Title",adVarChar,adParamInput,255,strGameTitle)
		.Parameters.Append .CreateParameter("@Description",adLongVarChar,adParamInput,2147483647,strGameDescription)
		.Parameters.Append .CreateParameter("@Username",adVarChar,adParamInput,20,Session("Username"))
		.Parameters.Append .CreateParameter("@GameID",adInteger,adParamOutput,8)
		.Execute
		NewGame = .Parameters("@GameID").Value
	End With

	  Dim log : Set log = New Logger : log.CreateGame(NewGame)

end function

    %>
