Function SafeHTMLEncode(s)
	If HasHtml(s) Then SafeHTMLEncode = s Else SafeHTMLEncode = Replace(s,vbCrLf,"<br/>")
End Function

Dim HTML_HasHtml_Regexp
Function HasHtml(s)
	If Not IsObject(HTML_HasHtml_Regexp) Then Set HTML_HasHtml_Regexp = New Regexp
	With HTML_HasHtml_Regexp
		.Pattern = "<(.|\n)+?>"
		.IgnoreCase = True
		HasHtml = .Test(s)
	End With
End Function

Dim HTML_stripHTML_Regexp
Function stripHTML(strHTML)
'Strips the HTML tags from strHTML
  If Not IsObject(HTML_stripHTML_Regexp) Then Set HTML_stripHTML_Regexp = New Regexp
  
  Dim objRegExp, strOutput
  Set objRegExp = HTML_stripHTML_Regexp

  objRegExp.IgnoreCase = True
  objRegExp.Global = True
  objRegExp.Pattern = "<(.|\n)+?>"

  'Replace all HTML tag matches with the empty string
  strOutput = objRegExp.Replace(strHTML, "")
  
  'Replace all < and > with &lt; and &gt;
  strOutput = Replace(strOutput, "<", "&lt;")
  strOutput = Replace(strOutput, ">", "&gt;")
  
  stripHTML = strOutput    'Return the value of strOutput

  Set objRegExp = Nothing
End Function