<% option explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="navigation.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<%
CheckHeader "variable.aspx"

Dim Action : Action = LCase(Request.Form("pbAction"))
Dim Value : Value = Request.Form("pbValue")
Dim IsPostBack : IsPostBack = _
    Request.Form("postback") = Request.ServerVariables("SCRIPT_NAME")
Dim GameID : If Len(Request.Form("GameID")) _
	Then GameID = CLng(Request.Form("GameID")) _
	Else GameID = CLng(Request.QueryString("GameID"))
Dim Variable : If Len(Request.Form("Variable")) _
	Then Variable = Request.Form("Variable") _
	Else Variable = Request.QueryString("Variable")
	
Dim Conn
	Set Conn = Server.CreateObject("ADODB.Connection")
	Conn.Open Application("ConnectionString")

	
ValidateGameWithConn GameID, Conn

Select Case Action
	Case "cancel" : Navigate "variables", GameId
	Case "save" : Save: Navigate "variables", GameId
	Case "renamevariable" : Save: RenameVariable GameID, Value, Request.Form("NewVariable") : Variable = Request.Form("NewVariable")
	Case "nav" : Navigate Value,GameID
End Select		

Dim MinValue, MaxValue, DefaultValue, DisplayOnPage, AboveEventTrigger, BelowEventTrigger
Dim AboveEventDestinationPageId, BelowEventDestinationPageId
If Not IsEmpty(Variable) Then
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionSTring")
		.CommandText = _
			"SELECT [Min Value], [Max Value], [Default Value], [Display On Page], " & _
			"       [Min Event Trigger], [Max Event Trigger], " & _
			"       [Min Destination Page Id], [Max Destination Page Id] " & _
			"  FROM [Game Variables Expanded] WHERE [Game ID] = ? AND [Variable] = ?"
		.Parameters.Append .CreateParameter("Game Id",adInteger,adParamInput,4,GameId)
		.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,250,Variable)	
		With .Execute
			If Not .EOF Then
				MinValue = EmptyIf(.Fields("Min Value"))
				MaxValue = EmptyIf(.Fields("Max Value"))
				DefaultValue = EmptyIf(.Fields("Default Value"))
				DisplayOnPage = CBool(.Fields("Display On Page"))
				AboveEventTrigger = EmptyIf(.Fields("Max Event Trigger"))
				BelowEventTrigger = EmptyIf(.Fields("Min Event Trigger"))
				AboveEventDestinationPageId = EmptyIf(.Fields("Max Destination Page Id"))
				BelowEventDestinationPageId = EmptyIf(.Fields("Min Destination Page Id"))
			End If
		End With
	End With
End If
		

%>



        <div id="mainContent"> 

		<h1>Advanced Editor &raquo; Variables</h1>		
		<% WriteSecondaryNavigation %>		

          <form name="mainForm" method="post"> 
            <h2>Variable Name</h2>
			<span class="smallerText">
			   Variables may contain only letters and numbers (first character must be a letter)
			   and may be no longer than 10 characters.<br/>
			   <% If IsEmpty(Variable) Then %>
	 		       <input type="text" name="Variable" maxlength="10" size="15" autofocus="true"> 
			   <% Else %>
	 		       <input type="hidden" name="Variable" value="<%=Variable%>">
				   <div style="border:1px solid black; padding:4px; margin-top:5px; width:200px; "><%=Variable%></div>
				   <% If Variable <> "SCORE" Then %>
				   <a href="#" onClick="renameVariable();return false;">[rename]</a>
				   <% End If %>
			   <% End If %>

            </span> 
			<p>&nbsp;</p>
			<h2>Values</h2>
			<span class="smallerText">All values are optional. If a value has a minimum value, no matter how much you subtract
			from it, it will never go below the Minimum. The same is true for maximum value. If a value is entered for Starting,
			the variable will begin the game with that value.</span>
			<table border="0" cellpadding="0" cellspacing="0">
			<tr>
			  <th>Min Value</th>
			  <th><img src="../../i/spacer.gif" width="15" height="1"/></th>
			  <th>Max Value</th>
			  <th><img src="../../i/spacer.gif" width="15" height="1"/></th>			  
			  <th>Starting Value</th>
			</tr>
			<tr>
			  <td align="center"><input type="text" size="4" name="MinValue" maxlength="8" value="<%=MinValue%>"></td>
			  <td>&nbsp;</td>
			  <td align="center"><input type="text" size="4" name="MaxValue" maxlength="8" value="<%=MaxValue%>"></td>
			  <td>&nbsp;</td>			  
			  <td align="center"><input type="text" size="4" name="DefaultValue" maxlength="8" value="<%=DefaultValue%>"></td>
			</tr>
			</table>
			<p>&nbsp;</p>
			<h2>Events</h2>			
			<span class="smallerText">Events are optional. If this variable goes above or below the values entered, the player
			will be taken to the specified page instead of going to the page the link would take the player to.</span>
			<ul style="margin-top:5px; margin-left:20px; ">
			  <li>
			  If value goes <strong>Above</strong>
			  <input type="text" size="4" name="AboveEventTrigger" maxlength="8" value="<%=AboveEventTrigger%>">,
			  then go to page
			  <select name="AboveEventDestinationPageId" class="smallerText"><option value="">&nbsp;</option><%
				With Server.CreateObject("ADODB.Command")
					.ActiveConnection = Conn
					.CommandText = _
						"SELECT P.[Page Id], C.[Title] + ': ' +  P.[Title] AS [Title]"  & vbCrLf & _
						"  FROM [Game Chapters] C"  & vbCrLf & _
						"	   INNER JOIN [Game Pages] P"  & vbCrLf & _
						"			   ON C.[Game Id] = P.[Game Id]"  & vbCrLf & _
						"			  AND C.[Chapter Id] = P.[Chapter Id]"  & vbCrLf & _
						" WHERE P.[Game Id]=?"  & vbCrLf & _
						" ORDER BY C.[Chapter Id], P.[Page Id]"
					.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)	
					With .Execute
						Do While Not .EOF
							Response.Write "<option "
							If .Fields("Page ID") = AboveEventDestinationPageId Then Response.Write " selected='true' "
							Response.Write "value=""" & .Fields("Page ID").Value & """>" & _
								.Fields("Title").Value & "</option>"
						  .MoveNext()
						Loop
					End With 	
				End With
				%></select> 
			  </li>
			  <li>
			  If value goes <strong>Below</strong>
			  <input type="text" size="4" name="BelowEventTrigger" maxlength="8" value="<%=BelowEventTrigger%>">,
			  then go to page
			  <select name="BelowEventDestinationPageId" class="smallerText"><option value="">&nbsp;</option><%
				With Server.CreateObject("ADODB.Command")
					.ActiveConnection = Conn
					.CommandText = _
						"SELECT P.[Page Id], C.[Title] + ': ' +  P.[Title] AS [Title]"  & vbCrLf & _
						"  FROM [Game Chapters] C"  & vbCrLf & _
						"	   INNER JOIN [Game Pages] P"  & vbCrLf & _
						"			   ON C.[Game Id] = P.[Game Id]"  & vbCrLf & _
						"			  AND C.[Chapter Id] = P.[Chapter Id]"  & vbCrLf & _
						" WHERE P.[Game Id]=?"  & vbCrLf & _
						" ORDER BY C.[Chapter Id], P.[Page Id]"
					.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)	
					With .Execute
						Do While Not .EOF
							Response.Write "<option "
							If .Fields("Page ID") = BelowEventDestinationPageId Then Response.Write " selected='true' "
							Response.Write "value=""" & .Fields("Page ID").Value & """>" & _
								.Fields("Title").Value & "</option>"
						  .MoveNext()
						Loop
					End With 	
				End With
				%></select> 
			  </li>			  
			</ul>
			<p>&nbsp;</p>
			<h2>Additional Options</h2>
			<input type="checkbox" id="chkDisplayOnPage" name="DisplayOnPage" value="true" <%If DisplayOnPage Then Response.Write " checked"%>/>
			<label for="chkDisplayOnPage">Display On All Pages</label><br/>
			<span class="smallerText">If this option is selected, the variable name and value will be displayed at the bottom of each page
			while the player goes through your game.</span>

			<p>&nbsp;</p>

			<% If IsEmpty(Variable) Then %>
	            <input type="button" name="save" value="Create New Variable" onClick="if (validate(this)) PostBack('save');"> 
			<% Else %>
	            <input type="button" name="save" value="Save Changes & Return to Variables" onClick="if (validate(this)) PostBack('save');"> 
			<% End If %>
			&nbsp;
	        <input type="button" name="cancel" value="Cancel" onClick="PostBack('cancel')"> 				
			
            <input type="hidden" name="Destination" value=""> 			
            <input type="hidden" name="pbAction" value=""> 
            <input type="hidden" name="pbValue" value=""> 
            <input type="hidden" name="GameID" value="<%=GameID%>"> 
			<input type="hidden" name="NewVariable">
            <input type="hidden" name="postback" value="<%=Request.ServerVariables("SCRIPT_NAME") %>" />
 			
			<% If IsEmpty(Variable) Then %>
			<input type="hidden" name="CreateNewVariable" value="yes">
			<% End If %>
	
          </form> 
        </div> 
 <% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
<%


Function NullIf(s)
	If IsEmpty(s) Then
		NullIf = Null
	ElseIf s = "" Then
		NullIf = Null
	Else
		NullIf = s
	End If
End Function

Function EmptyIf(s)
	If IsNull(s) Then
		EmptyIf = Empty
	ElseIf s = "" Then
		EmptyIf = Null
	Else
		EmptyIf = s
	End If
End Function

Sub Save

	If Not IsEmpty(Request.Form("CreateNewVariable")) Then
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Conn
			.CommandText = _
				"INSERT INTO [Game Variables] ([Game Id], [Variable]) " & _
				"VALUES (?, ?)"
			.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
			.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10,Variable)
	
			.Execute
		End With
	End If
	
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"UPDATE [Game Variables] " & _
			"   SET [Min Value] = ?, " & _
			"       [Max Value] = ?, " & _
			"       [Default Value] = ?, " & _			
			"       [Display On Page] = ? " & _			
			" WHERE [Game Id] = ? " & _
			"   AND [Variable]= ? "
		.Parameters.Append .CreateParameter("MinValue",adInteger,adParamInput,4,NullIf(Request.Form("MinValue")))
		.Parameters.Append .CreateParameter("MaxValue",adInteger,adParamInput,4,NullIf(Request.Form("MaxValue")))
		.Parameters.Append .CreateParameter("DefaultValue",adInteger,adParamInput,4,NullIf(Request.Form("DefaultValue")))
		.Parameters.Append .CreateParameter("DisplayOnPage",adInteger,adParamInput,4,CBool(Len(Request.Form("DisplayOnPage"))))

		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10,Variable)

		.Execute
	End With
	
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"DELETE [Game Variable Events] " & _
			" WHERE [Game Id] = ? " & _
			"   AND [Variable]= ? "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10,Variable)
		.Execute
	End With
	
	If Request.Form("AboveEventTrigger") <> "" Then
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Conn
			.CommandText = _
				"INSERT INTO [Game Variable Events] " & _
				" ([Game Id], [Variable], [Event Type], [Event Trigger], [Destination Type], [Destination]) " & _
				"VALUES (?, ?, 'Max', ?, 'Page', ?)"
			.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
			.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10,Variable)
			.Parameters.Append .CreateParameter("EventTrigger",adInteger,adParamInput,4,Request.Form("AboveEventTrigger"))
			.Parameters.Append .CreateParameter("Destination",adInteger,adParamInput,4,Request.Form("AboveEventDestinationPageId"))
			.Execute
		End With
	End If
	
	If Request.Form("BelowEventTrigger") <> "" Then
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Conn
			.CommandText = _
				"INSERT INTO [Game Variable Events] " & _
				" ([Game Id], [Variable], [Event Type], [Event Trigger], [Destination Type], [Destination]) " & _
				"VALUES (?, ?, 'Min', ?, 'Page', ?)"
			.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
			.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10,Variable)
			.Parameters.Append .CreateParameter("EventTrigger",adInteger,adParamInput,4,Request.Form("BelowEventTrigger"))
			.Parameters.Append .CreateParameter("Destination",adInteger,adParamInput,4,Request.Form("BelowEventDestinationPageId"))
			.Execute
		End With
	End If	
End Sub

Function RenameVariable(GameID, Variable, NewVariable)
	'On Error Resume Next
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandText = "UPDATE [Game Variables] SET [Variable]=? WHERE [Game Id]=? AND [Variable]=? "
		.Parameters.Append .CreateParameter("NewVariable",adVarChar,adParamInput,10,NewVariable)
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,8,GameID)
		.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10,Variable)		
		.Execute
	End With
End Function

%>