<% Option Explicit %>
<!-- #include file="../../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../../Includes/sessionValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../../Includes/ClientMessages.vbs"></script>
<script runat="server" language="vbscript" src="../../../Includes/CheckHeader.vbs"></script>
<script runat="server" language="vbscript" src="../duel.vbs"></script>
<!-- #include file="rpsHelper.asp" -->
<%
CheckHeader "newDuel.aspx"

ValidateSession



Dim target
If Request("target") = "" Then target = "../" Else target = Request("target")
	
Dim ChallengeeUsername
If Not IsEmpty(Request.Form("ChallengeeUsername")) _
	Then ChallengeeUsername = Request.Form("ChallengeeUsername") _
	Else ChallengeeUsername = Request.QueryString("Username")

If Not IsEmpty(Request.Form("duel")) Then IssueDuel
Sub IssueDuel
	With New Duel
		.DuelType = "RPS"
		.LoadFromForm Request.Form
		If IsValidChoice(.ChallengerChoice) Then
			If .IssueChallenge Then
				If LCase(.ChallengeeUsername)="cysid" Then
					.ChallengeeChoice = SelectRandomChoice
					.Winner = CalculateWinner(.ChallengeeChoice, .ChallengerChoice)
					.Accept
					'target = "../duel.asp?DuelId=" & .DuelId
				End If				
				AlertWithRedirect "Your challenge was issued!", target
			Else
				Alert "There was an error with your wager:" & vbCrLf & .ErrorMessage
			End If
		Else
			 Alert .ChallengerChoice & " is an invalid choice."
		End IF
	End With
End Sub



Function SelectRandomChoice()
	Randomize Timer
	Dim idx : idx = Int(Rnd * UBound(Choices))
	If idx > UBound(Choices) Then idx = UBound(Choices)
	If idx < 0 Then idx = 0
	SelectRandomChoice = Choices(idx)(0)
End Function




%>
<script language="javascript">
function validate(frm)
{
	if (frm.Wager.selectedIndex==0)
	{
		alert("Whoops! You need to select a wager ...");
		return false;
	}
	

	if (confirm("Are you sure you'd like to issue this challenge?")) frm.submit();
}
</script>

<form method="post">
<div id="maincontent">
 <h1>RPS Duel</h1>
 <p>The rules are simple. When you hit the DUEL button, the points you wagered will deducted from your account and placed in escrow. If your oponent declines the duel (or does not accept in suitable time), your points will be returned. If you win the duel, your points will be returned in double. You can probably guess what happens if you don't win the duel ... </p>
 <table border="0" cellspacing="5" cellpadding="0">
   <tr>
     <td valign="top"><img src="images\<%=Request.Querystring("choice") %>.gif" width="72" height="72" /></td>
     <td valign="top" width="10">&nbsp;</td>
     <td><table border="0" cellspacing="0" cellpadding="3">
       <tr>
         <td valign="top"><label>Member To Challenge</label>
         </td>
         <td><%=ChallengeeUsername%></td>
       </tr>
       <tr>
         <td valign="top"><label>Points To Wager</label></td>
         <td><select name="Wager">
             <option value="">Select Wager</option>
<% Dim i : For i = 1 to 5 %><option value="<%=i%>" <%If CStr(i) = Request.Form("Wager") Then Response.Write " selected"%>><%=i%></option><% Next%>
         </select></td>
       </tr>
         <td valign="top"><label>Your Choice:</label></td>
         <td><%=Request.Querystring("choice") %></td>
       </tr>
       <tr>
         <td valign="top"><div align="center"> </div></td>
         <td valign="top">
					<input type="button" value="Duel" onClick="validate(this.form)" />
					&nbsp;

					<!--<input name="cancel" type="button" value="Cancel" />-->
					<input type="button" value="Cancel" onclick="location=this.form.target.value" />

                    <input type="hidden" name="ChallengeeUsername" value="<%=Server.HTMLEncode(ChallengeeUsername)%>">
					<input type="hidden" name="ChallengerChoice" value="<%=Request.Querystring("choice") %>" />
					<input type="hidden" name="duel" value="duel">
					<input type="hidden" name="target" value="<%=Server.HTMLEncode(target)%>">
					</td>
       </tr>
     </table></td>
   </tr>
 </table>
</div></form>
